{#-#####################################################################
 # Jinja2 template for /etc/network/interfaces
 #======================================================================
 # Macros responsible for the generation of the inet stanza holding
 # common settings.
 ####################################################################-#}
{#======================================================================
 # Generate common stanza
 #----------------------------------------------------------------------
 # This macro is responsible for generating a dummy inet stanza
 # to wrap common Ethernet options and IPv4/IPv6 protocol deactivation
 # commands.
 #===================================================================-#}
{%- macro generate_common_stanza(interface, indexes) -%}
  {%- set TAB = "\t" -%}
  {%- set device = helpers.get_stanza_device(interface, indexes) -%}
  {%- set desc = interface['desc'] -%}
  {%- set lines = [] -%}

  {#- Set shortcut variables -#}
  {%- set ethernet = interface['ethernet'] -%}
  {%- set ipv4 = interface['inet4'] -%}
  {%- set ipv6 = interface['inet6'] -%}

  {#--------------------------------------------------------------------
   # Ethernet options
   #------------------------------------------------------------------#}
  {#- Fetch config settings -#}
  {%- set ethernet_is_randomized  = ethernet['randomized'] -%}
  {%- set ethernet_address        = ethernet['address'] -%}
  {%- set ethernet_mtu            = ethernet['mtu'] -%}

  {%- if ethernet_is_randomized is sameas true -%}
    {{ lines.append(TAB ~ "hwaddress random") }}
  {%- elif ethernet_address is not sameas None -%}
    {{ lines.append(TAB ~ "hwaddress " ~ ethernet_address) }}
  {%- endif -%}

  {%- if ethernet_mtu | int > 0 -%}
    {{ lines.append(TAB ~ "mtu " ~ ethernet_mtu | int) }}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # IPv4/IPv6/ARP deactivation
   #------------------------------------------------------------------#}
  {#- Fetch config settings -#}
  {%- set ipv4_is_enabled  = ipv4['enabled'] -%}
  {%- set arp_is_enabled   = ipv4['arp']['enabled'] -%}
  {%- set ipv6_is_enabled  = ipv6['enabled'] -%}

  {#- Disable as much of IPv4 as possible -#}
  {%- if ipv4_is_enabled is sameas false
      or arp_is_enabled is sameas false -%}
    {{ lines.append(
        TAB ~ "post-up ip link set dev " ~
        device ~ " arp off") }}
  {%- endif -%}

  {#- Disable IPv6 entirely -#}
  {%- if ipv6_is_enabled is sameas false -%}
    {{ lines.append(
        TAB ~ "post-up echo 1 > /proc/sys/net/ipv6/conf/" ~
        device ~ "/disable_ipv6") }}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Bonding options
   #------------------------------------------------------------------#}
  {%- if interface['type'] == 'bond' -%}
    {#- Fetch config settings -#}
    {%- set bond_hash_policy = interface['bond']['hash_policy'] -%}
    {%- set bond_mode        = interface['bond']['mode'] -%}
    {%- set bond_slaves      = interface['bond']['slaves'] -%}

    {#- Mode -#}
    {%- set native_mode = config.get_bond_native_mode(bond_mode) -%}
    {%- if native_mode is not sameas None -%}
      {{
        lines.append(
          TAB ~ "bond_mode " ~ native_mode)
      }}
    {%- endif -%}

    {#- Hash policy -#}
    {%- set native_hash_policy =
        config.get_bond_native_hash_policy(
          bond_mode,
          bond_hash_policy
        )
    -%}
    {%- if native_hash_policy -%}
      {{
        lines.append(
          TAB ~ "bond_xmit_hash_policy " ~ native_hash_policy)
      }}
    {%- endif -%}

    {#- Slaves -#}
    {%- set bond_slave_devices =
        config.get_device_names_from_interface_uids(
          bond_slaves,
          indexes) |
        from_json -%}
    {%- if bond_slave_devices -%}
      {{
        lines.append(
          TAB ~ "bond_slaves " ~ bond_slave_devices | join(" "))
      }}
    {%- endif -%}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Vlan options
   #------------------------------------------------------------------#}
  {%- if interface['type'] == 'vlan' -%}
    {#- Vlan parent device name -#}
    {%- set vlan_parent_device =
        config.get_device_name_from_interface_uid(
          interface['vlan']['parent'],
          indexes) -%}

    {%- if vlan_parent_device -%}
      {{
        lines.append(
          TAB ~ "vlan-raw-device " ~ vlan_parent_device)
      }}
    {%- endif -%}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Bridge options
   #------------------------------------------------------------------#}
  {%- if interface['type'] == 'bridge' -%}
    {#- Fetch config settings -#}
    {%- set bridge_members = interface['bridge']['members'] -%}
    {%- set stp_is_enabled = interface['bridge']['stp']['enabled'] -%}
    {%- set stp_fwd_delay  = interface['bridge']['stp']['fwd_delay'] -%}
    {%- set stp_priority   = interface['bridge']['stp']['priority'] -%}

    {#- Bridge member devices -#}
    {%- set bridge_member_devices =
        config.get_device_names_from_interface_uids(
          bridge_members,
          indexes) |
        from_json -%}

    {%- if bridge_member_devices -%}
      {{
        lines.append(
          TAB ~ "bridge_ports " ~ bridge_member_devices | join(" "))
      }}
    {%- endif -%}

    {#- Spanning Tree Protocol -#}
    {%-   if stp_is_enabled is sameas true -%}
      {{ lines.append(TAB ~ "bridge_stp on") }}
      {%- if stp_fwd_delay is not sameas None -%}
        {{ lines.append(TAB ~ "bridge_fd " ~ stp_fwd_delay | int) }}
      {%- endif -%}
      {%- if stp_hello_time is not sameas None -%}
        {{ lines.append(TAB ~ "bridge_hello " ~ stp_hello_time | int) }}
      {%- endif -%}
      {%- if stp_priority is not sameas None -%}
        {{ lines.append(
           TAB ~ "bridge_bridgeprio " ~ stp_priority | int) }}
      {%- endif -%}
    {%- elif stp_is_enabled is sameas false -%}
      {{ lines.append(TAB ~ "bridge_stp off") }}
    {%- endif -%}

  {%- endif -%}

  {#--------------------------------------------------------------------
   # Render stanza
   #--------------------------------------------------------------------
   # This stanza must be rendered even if empty.
   #------------------------------------------------------------------#}
  {{ helpers.render_stanza(device, "inet", "manual", lines, desc) }}
{%- endmacro -%}

{#======================================================================
 # Generate default stanza
 #----------------------------------------------------------------------
 # This macro is responsible for generating a default, dummy stanza
 # holding cross-family settings, such as Ethernet options, or IPv4/IPv6
 # disablement logic.
 # In contexts where both IPv4 and IPv6 are disabled, the default stanza
 # will be the only one present. If IPv4 and/or IPv6 are enabled, the
 # use of a default stanza will avoid repeating common settings, such
 # as Ethernet-related options, in the next stanzas.
 #===================================================================-#}
{%- macro generate(interface, indexes) -%}
    {#- Generate 'inet manual' common stanza -#}
    {%- set stanza = generate_common_stanza(interface, indexes) -%}
    {%- if stanza -%}
      {{ stanza ~ "\n" }}
    {%- endif -%}
{%- endmacro -%}
